/* $Id: UtilityToolBar.java 539 2012-08-26 08:42:21Z minao $ */
package smart_gs.swingui.toolbar;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToolBar;

import smart_gs.GSConstants;
import smart_gs.reasoning_web.swingui.ReasoningWebFrame;
import smart_gs.smleditor.swingui.LineSegEditor;
import smart_gs.swingui.AbstractGSWindow;
import smart_gs.swingui.toolbar.action.LineSegEditorActionListener;
import smart_gs.swingui.toolbar.action.ShowLinesActionListener;

@SuppressWarnings("serial")
public class UtilityToolBar extends JToolBar implements ActionListener{
	
	public UtilityToolBar(AbstractGSWindow parent) {
		JButton linesegshow = new JButton(new ImageIcon(GSConstants.ICON_PATH+"linesegment.png"));
		linesegshow.addActionListener(new ShowLinesActionListener(parent));
		linesegshow.setToolTipText("Line Segment Display Mode");
		this.add(linesegshow);
		
		JButton linesegeditor = new JButton(new ImageIcon(GSConstants.ICON_PATH+"linesegmentediting2.png"));
		linesegeditor.addActionListener(new LineSegEditorActionListener(parent));
		linesegeditor.setToolTipText("Open Line Segment Editor");
		this.add(linesegeditor);
		
		JButton rw = new JButton(new ImageIcon(GSConstants.ICON_PATH+"reasoningweb.png"));
		rw.addActionListener(this);
		rw.setToolTipText("Open Resioning Web");
		this.add(rw);
	}

	public void actionPerformed(ActionEvent e) {
		ReasoningWebFrame.getInstance().setVisible(true);
	}
}
